uniform mat4 lMVP;
uniform mat4 mMVIT;

varying vec4 diffuse, ambientGlobal, ambient;
varying vec3 normal,lightDir, halfVector;
varying float dist;
varying float visible;

const float PI = 3.14159265358979323846264338327950288419716939937510;

void calcLight(vec4 pos, vec3 n)
{	
	vec4 ecPos;
	vec3 aux;
	
	normal = normalize(gl_NormalMatrix * n);
	
	ecPos = gl_ModelViewMatrix * pos;
	aux = vec3(gl_LightSource[0].position-ecPos);
	lightDir = normalize(aux);

	dist = length(aux);

	halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;
}

void main (void)
{
	visible = 1.;

	calcLight(gl_Vertex, gl_Normal);	
   
	// shadow texture coordinates generation
	gl_TexCoord[1] = lMVP*gl_Vertex; 
	// transform vertex
	gl_Position = ftransform();

	// set color
	gl_FrontColor = gl_Color;
	gl_BackColor = gl_Color;

	// check if vertex faces away from light					
	vec3 nv =  vec3( mMVIT * vec4(gl_Normal, 0.) );		
	float a = acos( dot( normalize(nv), vec3(0.,0.,-1.) ) );	
	if( abs(a) <= PI/2.0 + 0.2 )								
	visible = 0.;										
	else														
	visible = 1.;   
}